package com.sibvisions.jasper;

import java.io.File;
import java.util.HashMap;

import javax.rad.io.RemoteFileHandle;

import com.sibvisions.rad.persist.jdbc.DBAccess;
import com.sibvisions.util.FileViewer;
import com.sibvisions.util.type.ResourceUtil;

import net.sf.jasperreports.engine.JasperCompileManager;
import net.sf.jasperreports.engine.JasperExportManager;
import net.sf.jasperreports.engine.JasperFillManager;
import net.sf.jasperreports.engine.JasperPrint;
import net.sf.jasperreports.engine.JasperReport;

public class JasperMain
{

    //~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
    // Initialization
    //~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

    /**
     * Creates a new instance of <code>JasperMain</code>.
     */
    public static void main(String[] pArgs) throws Exception
    {
        DBAccess dba = DBAccess.getDBAccess("jdbc:hsqldb:hsql://localhost/personsdb", "sa", "");
        dba.open();
        
        HashMap<String, Object> hmpParams = new HashMap<String, Object>();
        hmpParams.put("myID" , 1); // Integer
        hmpParams.put("myName" , "Timbo"); // String
         
        hmpParams.put("REPORT_CONNECTION", dba.getConnection()); // String
        
        // compile report
        JasperReport jasperReport = JasperCompileManager.compileReport(ResourceUtil.getResourceAsStream("/com/sibvisions/jasper/template/Leaf_Grey.jrxml"));
         
        // fill report
        JasperPrint jasperPrint = JasperFillManager.fillReport(jasperReport, hmpParams);
        //JasperPrint jasperPrint = JasperFillManager.fillReport(jasperReport, hmpParams, dba.getConnection());
         
        File fiPdf = File.createTempFile("report", ".pdf"); 
        
        // export report to PDF
        JasperExportManager.exportReportToPdfFile(jasperPrint, fiPdf.getAbsolutePath());
        
        RemoteFileHandle rfh = new RemoteFileHandle(fiPdf);
        
        FileViewer.open(fiPdf);
        
        System.exit(0);
    }

}
